#lang s-exp "../../../lang/main.rkt"


(kernel void (fwtKernelSketch [float* tArray] [int step])
  (: int tid group pair match)
  (: float t1 t2)
  (= tid (get_global_id 0))
  (= group (idx tid step))                              ; (% tid step)
  (= pair  (+ (* (<< step 1) (idx tid step)) group))    ; (/ tid step)
  (= match (+ pair step))
  (= t1 [tArray pair])
  (= t2 [tArray match])
  (= [tArray pair]  (+ t1 t2))
  (= [tArray match] (- t1 t2)))

(kernel void (fwtKernel4Sketch [float4* tArray] [int step])
  (: int tid group pair match)
  (: float4 t1 t2)
  (= tid (get_global_id 0))
  (= step [choose step (/ step 4) (* step 4) (% step 4)]) ; (/ step 4)
  (= group (% tid step))
  (= pair  (+ (* (<< step 1) (/ tid step)) group)) 
  (= match (+ pair step))
  (= t1 [tArray pair])
  (= t2 [tArray match])
  (= [tArray pair]  (+ t1 t2))
  (= [tArray match] (- t1 t2)))

(grammar int (op [int left] [int right])
 [choose (+ left right)
         (- left right)
         (/ left right)
         (* left right)
         (% left right)])

(grammar int (idx [int tid] [int step])
  (op (choose tid step (?? int))
      (choose tid step (?? int)))) 

(kernel void (fwtKernel [float* tArray] [int step])
  (: int tid group pair match)
  (: float t1 t2)
  (= tid (get_global_id 0))
  (= group (% tid step))
  (= pair  (+ (* (<< step 1) (/ tid step)) group)) 
  (= match (+ pair step))
  (= t1 [tArray pair])
  (= t2 [tArray match])
  (= [tArray pair]  (+ t1 t2))
  (= [tArray match] (- t1 t2)))

(kernel void (fwtKernel4 [float4* tArray] [int step])
  (: int tid group pair match)
  (: float4 t1 t2)
  (= tid (get_global_id 0))
  (= step (/ step 4))
  (= group (% tid step))
  (= pair  (+ (* (<< step 1) (/ tid step)) group)) 
  (= match (+ pair step))
  (= t1 [tArray pair])
  (= t2 [tArray match])
  (= [tArray pair]  (+ t1 t2))
  (= [tArray match] (- t1 t2)))

